<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

<!--
	=======
	tokenizer 
	=======
	input parameters:
	* token_nr	: the token that has to be fetched
	* string		: token array
	* delimiter	: token delimiter
-->

<xsl:template name="tokenizer">
	<xsl:param name="token_nr"/> 
	<xsl:param name="string"/>
	<xsl:param name="delimiter"/>

	<xsl:choose>
		<xsl:when test='$token_nr != "1"'>
			<xsl:call-template name='tokenizer'>
				<xsl:with-param name='token_nr' select='number($token_nr) - 1'/>
				<xsl:with-param name='string' select='substring-after($string,$delimiter)'/>
				<xsl:with-param name='delimiter' select='$delimiter'/>
			</xsl:call-template>
		</xsl:when>
		<xsl:when test='contains($string,$delimiter)'>
			<xsl:value-of select='substring-before($string,$delimiter)'/>        
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select='$string'/>
		</xsl:otherwise>
	</xsl:choose>
	
</xsl:template>

<!--
	============
	reverse-string
	============
	input parameters:
	* string		: string to be reversed
	* length		: lenght of input string
-->


<xsl:template name="reverse-string">
	<xsl:param name="string" />
	<xsl:param name="length" />
	<xsl:if test="$length > 0">
		<xsl:value-of select="substring($string,$length,1)"/>
		<xsl:call-template name="reverse-string">
			<xsl:with-param name="string" select="$string"/>
			<xsl:with-param name="length" select="$length - 1"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>

</xsl:stylesheet>
